/*
PolyGun

Copyright (c) 2023 mrkubax10 <mrkubax10@onet.pl>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

#ifndef POLYGUN_RENDERER_MESH_RENDERER_HPP
#define POLYGUN_RENDERER_MESH_RENDERER_HPP

#include <glm/glm.hpp>
#include <vector>

namespace polygun::renderer {
	class Mesh;
	class Texture;
	class Camera;
	class Shader;
	class MeshRenderer {
	public:
		MeshRenderer();
		virtual ~MeshRenderer(){}

		void translate(const glm::vec3& pos);
		void translate(const glm::vec2& pos);
		void rotate(const glm::vec3& rot, float angle);
		void rotate(const glm::vec2& rot, float angle);
		void scale(const glm::vec3& scl);
		void scale(const glm::vec2& scl);

		virtual void render(Mesh* mesh, const glm::vec4& color) = 0;
		virtual void render_textured(Mesh* mesh, Texture* texture) = 0;
		virtual void render_with_multiple_textures(Mesh* mesh, const std::vector<Texture*>& textures) = 0;
		virtual void set_shader(Shader* shader) = 0;
		virtual void set_camera(Camera* camera) = 0;
		virtual void set_3d_rendering_mode(bool enable) = 0;
		virtual void set_alpha_blending_mode(bool enable) = 0;

	protected:
		Camera* m_camera;
		glm::mat4 m_transform;
	};
}

#endif // POLYGUN_RENDERER_MESH_RENDERER_HPP
